package jp.co.sds_corp.puzzle;

public class Cell
{
	public enum Mode {
		QUESTION, ANSWER
	}
	int number;
	Mode mode = Mode.ANSWER;
	boolean[] available;

	public Cell() {
		mode = Mode.ANSWER;
		available = new boolean[9];
		for (int i = 0; i < 9; i++) {
			available[i] = true;
		}
	}

	synchronized void clear() {
		number = 0;
		for (int i = 0; i < 9; i++) {
			available[i] = true;
		}
		mode = Mode.ANSWER;
	}

	synchronized void copy(Cell src) {
		this.number = src.getNumber();
		this.mode = src.getMode();
		for (int i = 0; i < 9; i++) {
			this.available[i] = src.available(i + 1);
		}
	}

	/**
	* availableを設定します。
	* @param	var		設定するデータ
	*/
	public synchronized void setAvailable( int num, boolean var ) {
		this.available[num - 1] = var;
	}
	/**
	* availableを取得します。
	* @return	available
	*/
	public synchronized boolean available(int num) {
		return available[num - 1];
	}

	/**
	* numberを設定します。
	* @param	var		設定するデータ
	*/
	public synchronized void setNumber( int var ) {
		this.number = var;
	}
	/**
	* numberを取得します。
	* @return	number
	*/
	public synchronized int getNumber() {
		return number;
	}

	/**
	* modeを設定します。
	* @param	var		設定するデータ
	*/
	public synchronized void setMode( Mode var ) {
		this.mode = var;
	}
	/**
	* modeを取得します。
	* @return	mode
	*/
	public synchronized Mode getMode() {
		return mode;
	}

	/**
	* availableを設定します。
	* @param	var		設定するデータ
	*/
	public synchronized void setAvailable( boolean[] var ) {
		this.available = var;
	}
	/**
	* availableを取得します。
	* @return	available
	*/
	public synchronized boolean[] getAvailable() {
		return available;
	}

}
