package	jp.co.sds_corp.puzzle;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FileDialog;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.URL;
import java.util.Hashtable;
import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ButtonGroup;
import javax.swing.DefaultCellEditor;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JTable;
import javax.swing.SwingUtilities;
import javax.swing.border.LineBorder;
import javax.swing.event.TableModelEvent;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;

import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class NumPuzzlePnl extends JFrame
{
	static final CmnLogger logger = CmnLogFactory.getLogger();
	JTable	tbl = new JTable( 9, 9 );
	private ResourceBundle resources;
	private Hashtable<String,JMenuItem> menuItems;
	private Hashtable<String,ButtonGroup> menuGrp;
	private JMenuBar menubar;
	private Hashtable<Object,Action> commands;
	JButton	BT_AUTO;
	NumPuzzle	logic;
	Cell.Mode	mode = Cell.Mode.QUESTION;
	boolean	bAssist = false;
	Component	parent;
	boolean bAuto = false;

	public static final String imageSuffix = "Image";
	public static final String labelSuffix = "Label";
	public static final String actionSuffix = "Action";
	public static final String typeSuffix = "Type";
	public static final String groupSuffix = "Group";
	public static final String tipSuffix = "Tooltip";

	PuzzleRenderer pr;
	PuzzleEditor pe;

	public NumPuzzlePnl( Component parent ) {
		super( "Numeric Puzzle" );
		this.parent = parent;
		try {
			Locale	loc = Locale.getDefault();
/*
			if ( System.getProperty( "user.language" ) != null &&
				System.getProperty( "user.country" ) != null )
			{
				loc = new Locale( System.getProperty( "user.language" ),
									System.getProperty( "user.country" ) );
			}
*/
			resources = ResourceBundle.getBundle( "NumPuzzle", loc );
		} catch ( MissingResourceException ex ) {
			logger.error( this, "NumPuzzle.properties not found", ex );
			throw( ex );
		}
		logic = new NumPuzzle( this );

		getContentPane().setLayout( new BorderLayout() );
		setResizable( false );

		tbl.setModel( new PuzzleTableModel( 9, 9 ) );
		tbl.setRowHeight( 40 );
		String[]	data = {
			" ", "1", "2", "3", "4", "5", "6", "7", "8", "9"
		};
		JComboBox	cell = new JComboBox( data );
		Font font = new Font( "Dialog", Font.BOLD, 16 );
		cell.setFont( font );
		cell.setMaximumRowCount(10);
		pe = new PuzzleEditor( cell );
		pr = new PuzzleRenderer();
		for ( int i = 0; i < 9; i++ ) {
			TableColumn col = tbl.getColumnModel().getColumn(i);
			col.setCellRenderer( pr );
			col.setCellEditor( pe );
		}
		getContentPane().add( tbl, BorderLayout.CENTER );

		JPanel pnl = new JPanel() {
			private static final long serialVersionUID = 1L;
			public Dimension getPreferredSize() {
				return new Dimension( 300, 100 );
			}
		};
		pnl.setLayout( new BorderLayout() );
		JPanel pnl1 = new JPanel();
		JPanel pnl2 = new JPanel();

		BT_AUTO = new JButton( "Auto" );
		BT_AUTO.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				pe.stopSel();
				setModeMenu( Cell.Mode.ANSWER );
				if ( isAuto() ) {
					logic.stopThread();
					((JButton )ev.getSource()).setText( "Auto" );
					setAuto(false);
				} else {
					setAuto(true);
					((JButton )ev.getSource()).setText( "Stop" );
					logic.start();
				}
//				setData();
			}
		});
		pnl1.add( BT_AUTO );

		JButton	BT_CHECK = new JButton( "Check" );
		BT_CHECK.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				checkAll();
			}
		} );
		pnl1.add( BT_CHECK );
		JButton BT_HINT = new JButton( "Hint" );
		BT_HINT.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				pe.stopSel();
				setModeMenu( Cell.Mode.ANSWER );
				int nRet = logic.hint();
				if ( nRet > 0 ) {
					String reason = null;
					switch ( nRet ) {
					case 1: reason = "横の中ではそこにしか入りません"; break;
					case 2: reason = "縦の中ではそこにしか入りません"; break;
					case 3: reason = "ブロックの中ではそこにしか入りません"; break;
					case 4: reason = "そこはその数字しか入りません"; break;
					}
					JOptionPane.showMessageDialog( NumPuzzlePnl.this,
								"(" + (logic.getHintX()+1) + "," + (logic.getHintY()+1)
								+ ")に" + logic.getHintNum() + "が入ります\n"
								+ reason,
								"Hint!",
								JOptionPane.INFORMATION_MESSAGE);
				}
			}
		});
		pnl1.add( BT_HINT );

		JLabel lbl = new JLabel( getResourceString( "LblSample" ));
		pnl2.add( lbl );

		JComboBox smpCmb = createSample();
		if ( smpCmb != null ) {
			pnl2.add( smpCmb );
		}
		pnl.add( pnl1, BorderLayout.NORTH );
		pnl.add( pnl2, BorderLayout.SOUTH );
		getContentPane().add( pnl, BorderLayout.SOUTH );

		menuGrp = new Hashtable<String,ButtonGroup>();
		menuItems = new Hashtable<String,JMenuItem>();
		commands = new Hashtable<Object,Action>();
		Action[] actions = defaultActions;
		for (int i = 0; i < actions.length; i++) {
			Action a = actions[i];
			//commands.put(a.getText(Action.NAME), a);
			commands.put(a.getValue(Action.NAME), a);
		}
		menubar = createMenubar();
		getContentPane().add( menubar, BorderLayout.NORTH );
		setModeMenu( Cell.Mode.QUESTION );

		pack();
		Insets ins = getInsets();
		setSize( 400, 480+ins.top+ins.bottom );

		setVisible(true);
	}

	class SampleList {
		String	file;
		String	desc;
	}
	Vector<SampleList>	samples = new Vector<SampleList>();

	JComboBox createSample() {
		JComboBox cb = new JComboBox();
		cb.addItem( "Samples" );
		String	s;
		try {
			URL url = this.getClass().getResource( "/sample/sample.list" );
			InputStream is = url.openConnection().getInputStream();
			BufferedReader br = new BufferedReader( new InputStreamReader( is, "UTF-8" ));
			for ( ;; ) {
				s = br.readLine();
				if ( s == null ) {
					break;
				}
				SampleList dat = new SampleList();
				StringTokenizer	tok = new StringTokenizer( s, "\t" );
				dat.file = tok.nextToken();
				dat.desc = tok.nextToken();
				samples.add( dat );
				cb.addItem( dat.desc );
			}
		} catch ( Exception ex ) {
			logger.error(this, "create sample error", ex);
			return null;
		}
		cb.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				JComboBox cb = (JComboBox )ev.getSource();
				int nSel = cb.getSelectedIndex();
				if ( nSel > 0 ) {
					SampleList dat = (SampleList)samples.get( nSel - 1 );
					loadFile( "/sample/" + dat.file );
				}
			}
		} );
		return cb;
	}

	class PuzzleTableModel extends DefaultTableModel {
		private static final long serialVersionUID = 1L;
		PuzzleTableModel( int x, int y ) {
			super( x, y );
		}
		public boolean isCellEditable( int row, int col ) {
			if (( getMode() == Cell.Mode.ANSWER ) && ( logic.getMode( col, row ) == Cell.Mode.QUESTION )) {
				return false;
			}
			return true;
		}
		public Object getValueAt(int row, int col) {
			int data = logic.getData( col, row );
			if (data == 0) {
				return null;
			}
			return String.valueOf(data);
		}
		public void setValueAt(Object value, int row, int col) {
//			logger.debug("setValueAt [" + col + "," + row + "]=" + value);
			if (value == null) {
				logic.clear(col, row);
			} else {
				try {
					int nVal = Integer.valueOf((String )value);
					if ( bAssist ) {
						if ( !logic.isLegal( col, row, nVal ) ) {
							return;
						}
					}
					logic.setData(col, row, nVal, getMode());
				} catch (Exception ex) {
					logic.clear(col, row);
				}
			}
			super.setValueAt(value, row, col);
			if (logic.isInputFinished()) {
				checkAll();
			}
		}
	}

	class PuzzleRenderer extends DefaultTableCellRenderer {
		private static final long serialVersionUID = 1L;
		public Component getTableCellRendererComponent( JTable tbl, Object obj,
							boolean isSelected, boolean hasFocus, int row, int clm ) {
			setBorder( new PuzzleBorder( row, clm ));
			setHorizontalAlignment( CENTER );
			if ( obj != null ) {
				setText( (String )obj );
			} else {
				setText( "" );
			}
			Cell.Mode mode = logic.getMode( clm, row );
			if ( mode == Cell.Mode.ANSWER ) {
				setForeground( Color.black );
				setFont( new Font( "Dialog", Font.BOLD, 30 ));
			} else {
				setForeground( Color.blue );
				setFont( new Font( "Dialog", Font.BOLD|Font.ITALIC, 30 ));
			}
			return this;
		}
	}

	class PuzzleEditor extends DefaultCellEditor {
		private static final long serialVersionUID = 1L;
		PuzzleEditor( JComboBox combo ) {
			super( combo );
		}
/*
		public Component getTableCellEditorComponent( JTable tbl, Object obj,
							boolean isSelected, int row, int clm ) {
			((JComboBox )getComponent()).setBorder( new PuzzleBorder( row, clm ));
			return getComponent();
		}
*/
		public void stopSel() {
			fireEditingStopped();
		}
	}

	class PuzzleBorder extends LineBorder {
		private static final long serialVersionUID = 1L;
		int row, clm;
		PuzzleBorder( int row, int clm ) {
			super( Color.black );
			this.row = row;
			this.clm = clm;
		}
		public void paintBorder( Component c, Graphics g,
								int x, int y, int width, int height) {
//			super.paintBorder( c, g, x, y, width, height );
			Color oldColor = g.getColor();
			g.setColor( lineColor );
			g.drawRect( x, y, width-2, height-2 );
			if (( row % 3 ) == 2 ) {
				for ( int i = 0; i < 3; i++ ) {
					g.drawLine( x, y+height-1-i, x+width, y+height-1-i );
				}
			}
			if (( clm % 3 ) == 2 ) {
				for ( int i = 0; i < 3; i++ ) {
					g.drawLine( x+width-1-i, y, x+width-1-i, y+height );
				}
			}
			g.setColor( oldColor );
		}
	}

	protected JMenuBar createMenubar() {
		JMenuBar	mb = new JMenuBar();

		String[]	menuKeys = tokenize( getResourceString( "menubar" ));
		for (int i = 0; i < menuKeys.length; i++) {
			JMenu m = createMenu( menuKeys[i] );
			if (m != null) {
				mb.add(m);
			}
		}
		return mb;
	}

	protected JMenu createMenu( String key ) {
		String[] itemKeys = tokenize( getResourceString( key ));
		JMenu menu = new JMenu( getResourceString( key + "Label" ));
		for (int i = 0; i < itemKeys.length; i++) {
			if (itemKeys[i].equals("-")) {
				menu.addSeparator();
			} else {
				JMenuItem mi = createMenuItem( itemKeys[i] );
				menu.add( mi );
			}
		}
		return menu;
	}

	protected JMenuItem createMenuItem( String cmd ) {
		JMenuItem mi;
		String type = getResourceString( cmd + typeSuffix );
		if ( type == null ) {
			mi = new JMenuItem( getResourceString( cmd + labelSuffix ));
		} else if ( type.equals( "radio" ) ) {
			mi = new JRadioButtonMenuItem( getResourceString( cmd + labelSuffix ));
		} else if ( type.equals( "check" )) {
			mi = new JCheckBoxMenuItem( getResourceString( cmd + labelSuffix ));
		} else {
			mi = new JMenuItem( getResourceString( cmd + labelSuffix ));
		}
		String grp = getResourceString( cmd + groupSuffix );
		if ( grp != null ) {
			ButtonGroup bg = (ButtonGroup )menuGrp.get( grp );
			if ( bg == null ) {
				bg = new ButtonGroup();
				menuGrp.put( grp, bg );
			}
			bg.add( mi );
		}
		URL url = getResource( cmd + imageSuffix );
		if ( url != null ) {
			mi.setHorizontalTextPosition( JButton.RIGHT );
			mi.setIcon( new ImageIcon( url ));
		}
		String astr = getResourceString( cmd + actionSuffix );
		if (astr == null) {
			astr = cmd;
		}
		mi.setActionCommand( astr );
		Action a = getAction( astr );
		if ( a != null ) {
			mi.addActionListener( a );
			a.addPropertyChangeListener( createActionChangeListener( mi ));
			mi.setEnabled( a.isEnabled());
		} else {
			mi.setEnabled( false );
		}
		menuItems.put( cmd, mi );
		return mi;
	}

	protected String getResourceString( String nm ) {
		String str;
		try {
			str = resources.getString( nm );
// @@@
/*
str = new String( str.getBytes( "8859_1" ), "EUC-JP" );
		} catch ( UnsupportedEncodingException mre ) {
			str = null;
*/
		} catch ( MissingResourceException ex ) {
			str = null;
		}
		return str;
	}

	protected URL getResource( String key ) {
		String name = getResourceString( key );
		if ( name != null ) {
			URL url = this.getClass().getResource( name );
			return url;
		}
		return null;
	}

	protected String[] tokenize( String input ) {
		Vector<String> v = new Vector<String>();
		StringTokenizer t = new StringTokenizer( input );
		String cmd[];

		while (t.hasMoreTokens()) {
			v.addElement(t.nextToken());
		}
		cmd = new String[v.size()];
		for (int i = 0; i < cmd.length; i++) {
			cmd[i] = (String) v.elementAt(i);
		}

		return cmd;
	}

	protected PropertyChangeListener createActionChangeListener( JMenuItem b ) {
		return new ActionChangedListener( b );
	}

	private class ActionChangedListener implements PropertyChangeListener {
		JMenuItem menuItem;

		ActionChangedListener( JMenuItem mi ) {
			super();
			this.menuItem = mi;
		}
		public void propertyChange( PropertyChangeEvent ev ) {
			String propertyName = ev.getPropertyName();
			if ( ev.getPropertyName().equals( Action.NAME )) {
				String text = (String) ev.getNewValue();
				menuItem.setText( text );
			} else if ( propertyName.equals( "enabled" )) {
				Boolean enabledState = (Boolean) ev.getNewValue();
				menuItem.setEnabled( enabledState.booleanValue() );
			}
		}
	}

	void setData() {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				TableModelEvent ev = new TableModelEvent(tbl.getModel());
				tbl.tableChanged(ev);
			}
		});
	}

	protected Action getAction( String cmd ) {
		return (Action) commands.get( cmd );
	}

	private Action[] defaultActions = {
		new NewAction(),
		new OpenAction(),
		new SaveAction(),
		new ExitAction(),
		new ModeqAction(),
		new ModeaAction(),
		new AssistAction(),
		new ResetAction(),
	};
	protected FileDialog fileDialog;
	class OpenAction extends NewAction {
		private static final long serialVersionUID = 1L;
		OpenAction() {
			super( "open" );
		}

		public void actionPerformed( ActionEvent ev ) {
			pe.stopSel();
			Frame frame = NumPuzzlePnl.this;
			if ( fileDialog == null ) {
				fileDialog = new FileDialog( frame );
			}
			fileDialog.setMode( FileDialog.LOAD );
			fileDialog.setVisible(true);
			String file = fileDialog.getFile();
			if ( file == null ) {
				return;
			}
			String directory = fileDialog.getDirectory();
			File f = new File( directory, file );
			if ( f.exists()) {
				try {
					loadFile( new URL( "file:/" + f.getPath() ));
				} catch ( Exception ex ) {}
			}
		}
	}
	class SaveAction extends NewAction {
		private static final long serialVersionUID = 1L;
		SaveAction() {
			super( "save" );
		}

		public void actionPerformed( ActionEvent ev ) {
			pe.stopSel();
			Frame frame = NumPuzzlePnl.this;
			if ( fileDialog == null ) {
				fileDialog = new FileDialog( frame );
			}
			fileDialog.setMode( FileDialog.SAVE );
			fileDialog.setVisible(true);
			String file = fileDialog.getFile();
			if ( file == null ) {
				return;
			}
			String directory = fileDialog.getDirectory();
			File f = new File( directory, file );
			try {
				PrintWriter out = new PrintWriter(
									new BufferedWriter( new FileWriter( f )));
				for ( int y = 0; y < 9; y++ ) {
					for ( int x = 0; x < 9; x++ ) {
						if ( logic.getMode( x, y ) == Cell.Mode.QUESTION ) {
							out.print( logic.getData( x, y ));
						} else {
							out.print( 0 );
						}
					}
					out.println();
				}
				out.close();
			} catch ( IOException ex ) {
				logger.error(this, "save error", ex);
			}
		}
	}

	class NewAction extends AbstractAction {
		private static final long serialVersionUID = 1L;
		NewAction() {
			super( "new" );
		}
		NewAction( String nm ) {
			super(nm);
		}
		public void actionPerformed( ActionEvent ev ) {
			pe.stopSel();
			setModeMenu( Cell.Mode.QUESTION );
			logic.clearAll();
			setData();
		}
	}

	class ExitAction extends AbstractAction {
		private static final long serialVersionUID = 1L;
		ExitAction() {
			super( "exit" );
		}
		public void actionPerformed( ActionEvent ev ) {
			if ( parent == null ) {
				System.exit( 0 );
			} else {
				setVisible(false);
			}
		}
	}

	class ModeqAction extends AbstractAction {
		private static final long serialVersionUID = 1L;
		ModeqAction() {
			super( "modeq" );
		}
		public void actionPerformed( ActionEvent ev ) {
			pe.stopSel();
			new ResetAction().actionPerformed(ev);
			setModeMenu( Cell.Mode.QUESTION );
		}
	}
	class ModeaAction extends AbstractAction {
		private static final long serialVersionUID = 1L;
		ModeaAction() {
			super( "modea" );
		}
		public void actionPerformed( ActionEvent ev ) {
			pe.stopSel();
			setModeMenu( Cell.Mode.ANSWER );
		}
	}
	class AssistAction extends AbstractAction {
		private static final long serialVersionUID = 1L;
		AssistAction() {
			super( "assist" );
		}
		public void actionPerformed( ActionEvent ev ) {
			bAssist = !bAssist;
		}
	}

	class ResetAction extends AbstractAction {
		private static final long serialVersionUID = 1L;
		ResetAction() {
			super( "reset" );
		}
		public void actionPerformed( ActionEvent ev ) {
			pe.stopSel();
			for ( int y = 0; y < 9; y++ ) {
				for ( int x = 0; x < 9; x++ ) {
					if ( logic.getMode( x, y ) == Cell.Mode.ANSWER ) {
						logic.setData( x, y, 0, Cell.Mode.ANSWER );
						for ( int d = 1; d <= 9; d++ ) {
							logic.setAvailable( x, y, d, true );
						}
					}
				}
			}
			setData();
		}
	}

	void loadFile( String file ) {
		try {
			URL url = this.getClass().getResource( file );
			loadFile( url );
		} catch ( Exception ex ) {}
	}

	void loadFile( URL url ) {
		logger.debug(this, "loadFile[" + url + "]");
		setModeMenu( Cell.Mode.ANSWER );
		logic.clearAll();
		try {
			logic.readFile( url.openConnection().getInputStream() );
		} catch ( Exception ex ) {
			logger.error(this, "file load error", ex);
		}
		logic.copyAll();
		setData();
	}

	public synchronized boolean isAuto() {
		return bAuto;
	}

	public synchronized void setAuto(boolean bAuto) {
		this.bAuto = bAuto;
	}

	synchronized void setMode( Cell.Mode var ) {
		mode = var;
	}
	synchronized Cell.Mode getMode() {
		return mode;
	}

	void setModeMenu( Cell.Mode mode ) {
		setMode( mode );
		JMenuItem	mi = null;
		switch ( mode ) {
		case QUESTION:
			mi = (JMenuItem )menuItems.get( "modeq" );
			break;
		case ANSWER:
			mi = (JMenuItem )menuItems.get( "modea" );
			break;
		}
		if ( mi != null ) {
			mi.setSelected( true );
		}
	}

	void checkAll() {
		boolean bRet = logic.checkAll();
		if ( bRet ) {
			JOptionPane.showMessageDialog( this,
						"完了しました",
						"Complete",
						JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showMessageDialog( this,
						logic.getErrMsg(),
						"Alert",
						JOptionPane.ERROR_MESSAGE);
		}
	}

	public static void main( String[] args ) {
		NumPuzzlePnl frame = new NumPuzzlePnl( null );
		frame.addWindowListener( new WindowAdapter() {
			public void windowClosing( WindowEvent ev ) {
				System.exit( 0 );
			}
		} );
	}
}
